/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:15:31 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.books.model;

/**
 * Model definition for Bookshelf.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Bookshelf extends com.google.api.client.json.GenericJson {

  /**
   * Whether this bookshelf is PUBLIC or PRIVATE.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String access;

  /**
   * Created time for this bookshelf (formatted UTC timestamp with millisecond resolution).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime created;

  /**
   * Description of this bookshelf.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Id of this bookshelf, only unique by user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer id;

  /**
   * Resource type for bookshelf metadata.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * URL to this resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String selfLink;

  /**
   * Title of this bookshelf.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * Last modified time of this bookshelf (formatted UTC timestamp with millisecond resolution).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime updated;

  /**
   * Number of volumes in this bookshelf.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer volumeCount;

  /**
   * Last time a volume was added or removed from this bookshelf (formatted UTC timestamp with
   * millisecond resolution).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime volumesLastUpdated;

  /**
   * Whether this bookshelf is PUBLIC or PRIVATE.
   * @return value or {@code null} for none
   */
  public java.lang.String getAccess() {
    return access;
  }

  /**
   * Whether this bookshelf is PUBLIC or PRIVATE.
   * @param access access or {@code null} for none
   */
  public Bookshelf setAccess(java.lang.String access) {
    this.access = access;
    return this;
  }

  /**
   * Created time for this bookshelf (formatted UTC timestamp with millisecond resolution).
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getCreated() {
    return created;
  }

  /**
   * Created time for this bookshelf (formatted UTC timestamp with millisecond resolution).
   * @param created created or {@code null} for none
   */
  public Bookshelf setCreated(com.google.api.client.util.DateTime created) {
    this.created = created;
    return this;
  }

  /**
   * Description of this bookshelf.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Description of this bookshelf.
   * @param description description or {@code null} for none
   */
  public Bookshelf setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Id of this bookshelf, only unique by user.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getId() {
    return id;
  }

  /**
   * Id of this bookshelf, only unique by user.
   * @param id id or {@code null} for none
   */
  public Bookshelf setId(java.lang.Integer id) {
    this.id = id;
    return this;
  }

  /**
   * Resource type for bookshelf metadata.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Resource type for bookshelf metadata.
   * @param kind kind or {@code null} for none
   */
  public Bookshelf setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * URL to this resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getSelfLink() {
    return selfLink;
  }

  /**
   * URL to this resource.
   * @param selfLink selfLink or {@code null} for none
   */
  public Bookshelf setSelfLink(java.lang.String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  /**
   * Title of this bookshelf.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Title of this bookshelf.
   * @param title title or {@code null} for none
   */
  public Bookshelf setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  /**
   * Last modified time of this bookshelf (formatted UTC timestamp with millisecond resolution).
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getUpdated() {
    return updated;
  }

  /**
   * Last modified time of this bookshelf (formatted UTC timestamp with millisecond resolution).
   * @param updated updated or {@code null} for none
   */
  public Bookshelf setUpdated(com.google.api.client.util.DateTime updated) {
    this.updated = updated;
    return this;
  }

  /**
   * Number of volumes in this bookshelf.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getVolumeCount() {
    return volumeCount;
  }

  /**
   * Number of volumes in this bookshelf.
   * @param volumeCount volumeCount or {@code null} for none
   */
  public Bookshelf setVolumeCount(java.lang.Integer volumeCount) {
    this.volumeCount = volumeCount;
    return this;
  }

  /**
   * Last time a volume was added or removed from this bookshelf (formatted UTC timestamp with
   * millisecond resolution).
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getVolumesLastUpdated() {
    return volumesLastUpdated;
  }

  /**
   * Last time a volume was added or removed from this bookshelf (formatted UTC timestamp with
   * millisecond resolution).
   * @param volumesLastUpdated volumesLastUpdated or {@code null} for none
   */
  public Bookshelf setVolumesLastUpdated(com.google.api.client.util.DateTime volumesLastUpdated) {
    this.volumesLastUpdated = volumesLastUpdated;
    return this;
  }

  @Override
  public Bookshelf set(String fieldName, Object value) {
    return (Bookshelf) super.set(fieldName, value);
  }

  @Override
  public Bookshelf clone() {
    return (Bookshelf) super.clone();
  }

}
